//--------------------------------------------------------------------------------------
// Copyright 2011 Intel Corporation
// All Rights Reserved
//
// Permission is granted to use, copy, distribute and prepare derivative works of this
// software for any purpose and without fee, provided, that the above copyright notice
// and this statement appear in all copies.  Intel makes no representations about the
// suitability of this software for any purpose.  THIS SOFTWARE IS PROVIDED "AS IS."
// INTEL SPECIFICALLY DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED, AND ALL LIABILITY,
// INCLUDING CONSEQUENTIAL AND OTHER INDIRECT DAMAGES, FOR THE USE OF THIS SOFTWARE,
// INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PROPRIETARY RIGHTS, AND INCLUDING THE
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Intel does not
// assume any responsibility for any errors which may appear in this software nor any
// responsibility to update it.
//--------------------------------------------------------------------------------------
#ifndef __CPUTFRAMESTATS_H__
#define __CPUTFRAMESTATS_H__

#include "CPUT.h"
#include "CPUTRefCount.h"

#define CPUT_FRAME_STAT_WINDOW_SIZE 5000

struct CPUTFrameInfo:public CPUTRefCount
{
    double TotalFrameTime;
    double TechniqueTime1;
    double TechniqueTime2;
};

class CPUTFrameStats
{
public:
    CPUTFrameStats();
    void AddFrame(CPUTFrameInfo& FrameEntry);
    CPUTFrameInfo GetAveragedFPS(double DesiredTimeWindow, unsigned int& NumberOfFrames);
    double GetHigh();
    double GetLow();

private:

    CPUTFrameInfo m_pArray[CPUT_FRAME_STAT_WINDOW_SIZE];
    unsigned int m_Head;
    double m_Low;
    double m_High;
};

#endif //#define __CPUTFRAMESTATS_H__
