// Copyright 2012 Intel Corporation
// All Rights Reserved
//



#ifndef H_CONSTANT_BUFFERS
#define H_CONSTANT_BUFFERS

///////////////////////
// Constants
///////////////////////

cbuffer ParticlePerFrameConstants 
{
    float  mScale;                             // Scene scale factor    
    float  mParticleSize;                      // Particles size in (pre)projection space
    float  mParticleOpacity;				   // (Max) Particle contrbution to the CDF
    float  mParticleAlpha;				       // (Max) Particles transparency
    float  mbSoftParticles;				       // Soft Particles Enable-Disable 
    float  mSoftParticlesSaturationDepth;      // Saturation Depth for Soft Particles.      
}

cbuffer ParticlePerPassConstants : register(b7)
{
    row_major   float4x4  mParticleWorldViewProj;
    row_major   float4x4  mParticleWorldView;
                float4    mEyeRight;
                float4    mEyeUp;       
}

#endif // H_CONSTANT_BUFFERS
