// Copyright 2012 Intel Corporation
// All Rights Reserved
//

#include "Common.hlsl"
#include "GBuffer.hlsl"
#include "AVSM.hlsl"
#include "AVSM_Gen.hlsl"
#include "VolumeSampler.hlsl"


//--------------------------------------------------------------------------------------
// Geometry phase
//--------------------------------------------------------------------------------------
Texture2D gDiffuseTexture                   : register(t24);
SamplerState gDiffuseSampler                : register(s12);


//--------------------------------------------------------------------------------------
// List texture
//--------------------------------------------------------------------------------------


FullScreenTriangleVSOut FullScreenTriangleVS(uint vertexID : SV_VertexID)
{
    FullScreenTriangleVSOut output;

    // Parametrically work out vertex location for full screen triangle
    float2 grid = float2((vertexID << 1) & 2, vertexID & 2);
    output.positionClip = float4(grid * float2(2.0f, -2.0f) + float2(-1.0f, 1.0f), 0.0f, 1.0f);
    output.positionViewport = output.positionClip;
    output.texCoord = grid;
    
    return output;
}
