// Copyright 2012 Intel Corporation
// All Rights Reserved
//

#ifndef H_VOLUME_SAMPLER
#define H_VOLUME_SAMPLER

// Generalized volume sampling function
float VolumeSample(in uint method, in float2 textureCoords, in float receiverDepth)
{
    switch (method) { 
        case(VOL_SHADOW_AVSM):
#ifdef AVSM_BILINEARF        
            return AVSMBilinearSample(textureCoords, receiverDepth);                                         
#else
            return AVSMPointSample(textureCoords, receiverDepth);                                         
#endif            
        case(VOL_SHADOW_AVSM_GEN):
#ifdef AVSM_GEN_SOFT
    #ifdef AVSM_GEN_BILINEARF    
			    return AVSMGenBilinearSampleSoft(textureCoords, receiverDepth); 
    #else
                return AVSMGenPointSampleSoft(textureCoords, receiverDepth); 
    #endif
#else
    #ifdef AVSM_GEN_BILINEARF    
			    return AVSMGenBilinearSample(textureCoords, receiverDepth); 
    #else
                return AVSMGenPointSample(textureCoords, receiverDepth); 
    #endif
#endif
        default:
            return 1.0f;
    }               
}


#endif // H_VOLUME_SAMPLER

